# Retrieve employee payslips

GET https://api.letsdeel.com/rest/v2/gp/workers/{id}/payslips

Returns a list of payslips for a Global Payroll (GP) employee, including each payslip's date range and current status. Use this endpoint to display payslip history or verify that payslips have been published before initiating a download. Requires the worker id (UUID), which can be obtained from the List GPworkers endpoint. Each payslip in the response includes an id that is required for the download endpoint. Supports only GP contract types.
 **Token scopes**: `payslips:read`

Reference: https://developer.deel.com/api/endpoints/payslips/get-gp-worker-payslips

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /gp/workers/{id}/payslips:
    get:
      operationId: get-gp-worker-payslips
      summary: Retrieve employee payslips
      description: >-
        Returns a list of payslips for a Global Payroll (GP) employee, including
        each payslip's date range and current status. Use this endpoint to
        display payslip history or verify that payslips have been published
        before initiating a download. Requires the worker id (UUID), which can
        be obtained from the List GPworkers endpoint. Each payslip in the
        response includes an id that is required for the download endpoint.
        Supports only GP contract types.
         **Token scopes**: `payslips:read`
      tags:
        - subpackage_payslips
      parameters:
        - name: id
          in: path
          description: Unique identifier for the worker.
          required: true
          schema:
            type: string
            format: uuid
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/payslips_getGPWorkerPayslips_Response_200'
        '400':
          description: Bad Request - Validation error or invalid parameters
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/RetrieveEmployeePayslips-v2026-01-01RequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the payslip.
        to:
          type: string
          format: date
          description: End date of the payslip period in ISO-8601 format.
        from:
          type: string
          format: date
          description: Start date of the payslip period in ISO-8601 format.
        status:
          type: string
          description: >-
            The current status of the payslip (e.g., AVAILABLE, PENDING,
            PUBLISHED).
      required:
        - id
        - to
        - from
        - status
      title: GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaDataItems
    payslips_getGPWorkerPayslips_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaDataItems
      required:
        - data
      title: payslips_getGPWorkerPayslips_Response_200
    GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaErrorsItems:
      type: object
      properties:
        message:
          type: string
          description: Error response
      required:
        - message
      title: GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaErrorsItems
    GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaRequest:
      type: object
      properties:
        method:
          type: string
          description: Method of the API
        status:
          type: number
          format: double
          description: Status of API response
      description: Error request details
      title: GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaRequest
    RetrieveEmployeePayslips-v2026-01-01RequestBadRequestError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaErrorsItems
          description: Error messages
        request:
          $ref: >-
            #/components/schemas/GpWorkersIdPayslipsGetResponsesContentApplicationJsonSchemaRequest
          description: Error request details
      required:
        - errors
      title: RetrieveEmployeePayslips-v2026-01-01RequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/gp/workers/6f50539e-9f62-45d0-a42e-62a62fbb984a/payslips")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```